// ALFAIM (PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	int i,d;

	if (argc != 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);
		disk.ReadDATA1(0x00, 0x00, 0x00, 0x10, 0x01, buff, 0x100);
		switch (buff[0x00])
		{
		case 0x00:
			printf("Disk C (PROGRAM DISK) F܂.\n");
			fcut("MUS01", 0x08, 0x04, 0x00, 0x01, 0x01, 0x0000, 0x1000);
			fcut("MUS02", 0x0a, 0x05, 0x00, 0x01, 0x01, 0x0000, 0x1000);
			continue;

		case 0x01:
			printf("Disk D (DATA 1 DISK)F܂.\n");
			continue;

		case 0x02:
			printf("Disk E (DATA 2 DISK)F܂.\n");
			continue;

		case 0x03:
			printf("Disk F (DATA 3 DISK)F܂.\n");
			continue;

		case 0x04:
			printf("Disk G (DATA 4 DISK)F܂.\n");
			continue;

		case 0x05:
			printf("Disk H (DATA 5 DISK)F܂.\n");
			fcut("MUS03", 0x0e, 0x07, 0x00, 0x01, 0x01, 0x0000, 0x1000);
			continue;

		case 0x0a:
			printf("Disk A (OPENING A DISK)F܂.\n");
			fcut("PROG",  0x01, 0x00, 0x01, 0x02, 0x01, 0x0000, 0x3f00);
			fcut("MUS00", 0x0f, 0x07, 0x01, 0x01, 0x01, 0x0000, 0x1000);
			continue;

		case 0x0b:
			printf("Disk B (OPENING B DISK)F܂.\n");
			continue;

		case 0x0c:
			printf("User Disk F܂.\n");
			continue;
		}
		printf("FłȂfBXNł.\n");
	}
	return 0;
}

