// CLUJU (PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int offset;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	int i,d;

	// for Disk A
	struct fpos ma[] =
	{
		{ 0x11, 0x0c, 0xc6, 0x043a }, // 
		{ 0x26, 0x01, 0x00, 0x0700 }, // 
		{ 0x26, 0x07, 0x00, 0x0300 }, // 
		{ 0x26, 0x0a, 0x00, 0x0100 }, // 
		{ 0x26, 0x0b, 0x00, 0x0200 }, // 
		{ 0x26, 0x0d, 0x00, 0x0300 }, // 
		{ 0x00, 0x00, 0x00, 0x0000 }, // End of Data
	};

	if (argc != 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);
		disk.ReadDATA1(0x3f, 0x1f, 0x01, 0x10, 0x01, buff, 0x100);
		switch (buff[1])
		{
		case 0x7f:
			printf("Disk A F܂.\n");
			fcut("DRIVER", 0x11, 0x08, 0x01, 0x01, 0x01, 0x0000, 0x1000);
			for (i=0; ma[i].sec; i++)
			{
				sprintf(fname,"MUS%02d",i);
				fcut(fname, ma[i].trk, ma[i].trk>>1, ma[i].trk&1, ma[i].sec, 0x01, ma[i].offset, ma[i].size);
			}
			continue;

		case 0x42:
			printf("Disk B F܂.\n");
			continue;
		}
	}
	return 0;
}

