// GALF STREEM (PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	int i,d;

	// for Disk C
	struct fpos md[] =
	{
		{ 0x0c, 0x01, 0x0800 },	// 00
		{ 0x0c, 0x09, 0x0800 },	// 01
		{ 0x0d, 0x01, 0x0800 },	// 02
		{ 0x0d, 0x09, 0x0800 },	// 03
		{ 0x0e, 0x01, 0x0800 },	// 04
		{ 0x0e, 0x09, 0x0800 },	// 05
		{ 0x0f, 0x01, 0x0800 },	// 06
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};

	if (argc != 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);
		disk.ReadDATA1(0x00, 0x00, 0x00, 0x10, 0x01, buff, 0x100);
		switch (*buff)
		{
		case 0x67:
			printf("Disk A F܂.\n");
			fcut("PROG", 0x01, 0x00, 0x01, 0x02, 0x01, 0x0000, 0x2f00);
			continue;

		case 0x1f:
			printf("Disk B F܂.\n");
			fcut("MUSOP1", 0x12, 0x09, 0x00, 0x01, 0x01, 0x0000, 0x1000);
			fcut("MUSOP2", 0x16, 0x0b, 0x00, 0x01, 0x01, 0x0000, 0x1000);
			continue;

		case 'A':
			printf("Disk C F܂.\n");
			for (i=0; md[i].sec; i++)
			{
				sprintf(fname,"MUS%03d",i);
				fcut(fname, md[i].trk, md[i].trk>>1, md[i].trk&1, md[i].sec, 0x01, 0x0000, md[i].size);
			}
			continue;

		case 'B':
			printf("Disk D F܂.\n");
			continue;
			
		case 'C':
			printf("Disk E F܂.\n");
			continue;
			
		case 'D':
			printf("Disk F F܂.\n");
			fcut("MUSEND", 0x38, 0x1c, 0x00, 0x01, 0x01, 0x0000, 0x1000);
			continue;

		case 'U':
			printf("User Disk F܂.\n");
			continue;
		}
		printf("FłȂfBXNł.\n");
	}
	return 0;
}

