// HERLESH (PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	int i,d;
	int dn = 0;

	if (argc<2 || argc>3)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file] (DiskNo.)\n",argv[0]);
		return 1;
	}

	if (argc==3)
	{
		// fBXNԍw
		dn = *argv[2]-'0';
		if (dn<1 || dn>3)
		{
		fprintf(stderr, "Usage: %s [d88file] (DiskNo.)\n",argv[0]);
		return 1;
		}
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);
		disk.ReadDATA1(0x00, 0x00, 0x00, 0x01, 0x01, buff, 0x100);
		if ((buff[0]==0xdb && dn==0) || dn==1)
		{
			printf("Disk A F܂.\n");
			fcut("DRIVER", 0x08, 0x04, 0x00, 0x01, 0x01, 0x0000, 0x0f00);
			fcut("MUSIC",  0x01, 0x00, 0x01, 0x01, 0x01, 0x0000, 0x0c00);
		}
		else if ((buff[0]==0x19 && dn==0) || dn==2)
		{
			printf("Disk B ܂ User Disk F܂.\n");
			fcut("OP",     0x4c, 0x26, 0x00, 0x01, 0x01, 0x0000, 0x0c00);
		}
		else if ((buff[0]==0x48 && dn==0) || dn==3)
		{
			printf("Disk C F܂.\n");
		}
		if (dn) return 0;
	}
	return 0;
}

