// _˗ (PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	int i,d;

	// for Disk A
	struct fpos ma[] =
	{
		{ 0x08, 0x01, 0x1000 },	// 00
		{ 0x0a, 0x01, 0x1000 },	// 01
		{ 0x15, 0x01, 0x0800 },	// 02
		{ 0x16, 0x01, 0x0800 },	// 03
		{ 0x17, 0x01, 0x0800 },	// 04
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};

	// for Disk B
	struct fpos mb[] =
	{
		{ 0x0d, 0x01, 0x0800 },	// 00
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};

	// for Disk F
	struct fpos mf[] =
	{
		{ 0x06, 0x01, 0x1000 },	// 00
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};

	if (argc != 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);
		disk.ReadDATA1(0x00, 0x00, 0x00, 0x10, 0x01, buff, 0x100);
		switch (*buff)
		{
		case 0x00:
			printf("Disk A F܂.\n");
			fcut("PROG", 0x01, 0x00, 0x01, 0x02, 0x01, 0x0000, 0x4f00);
			for (i=0; ma[i].sec; i++)
			{
				sprintf(fname,"MUS1%02d",i);
				fcut(fname, ma[i].trk, ma[i].trk>>1, ma[i].trk&1, ma[i].sec, 0x01, 0x0000, ma[i].size);
			}
			continue;

		case 0x01:
			printf("Disk B F܂.\n");
			for (i=0; mb[i].sec; i++)
			{
				sprintf(fname,"MUS2%02d",i);
				fcut(fname, mb[i].trk, mb[i].trk>>1, mb[i].trk&1, mb[i].sec, 0x01, 0x0000, mb[i].size);
			}
			continue;

		case 0x02:
			printf("Disk C F܂.\n");
			continue;

		case 0x03:
			printf("Disk D F܂.\n");
			continue;
			
		case 0x04:
			printf("Disk E F܂.\n");
			continue;
			
		case 0x05:
			printf("Disk F F܂.\n");
			for (i=0; mf[i].sec; i++)
			{
				sprintf(fname,"MUS6%02d",i);
				fcut(fname, mf[i].trk, mf[i].trk>>1, mf[i].trk&1, mf[i].sec, 0x01, 0x0000, mf[i].size);
			}
			continue;

		case 0x0a:
			printf("User Disk F܂.\n");
			continue;
		}
		printf("FłȂfBXNł.\n");
	}
	return 0;
}

