// gg[2 (PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	int i,d;

	// for Disk B
	struct fpos mb[] =
	{
		{ 0x4b, 0x01, 0x0800 },	// 00
		{ 0x4b, 0x09, 0x0800 },	// 00
		{ 0x4c, 0x01, 0x0800 },	// 00
		{ 0x4c, 0x09, 0x0800 },	// 00
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};

	if (argc != 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);
		disk.ReadDATA1(0x00, 0x00, 0x00, 0x10, 0x01, buff, 0x100);
		switch (*buff)
		{
		case 'A':
			printf("Disk A F܂.\n");
//			fcut("DRIVER_OP", 0x01, 0x00, 0x01, 0x01, 0x01, 0x0000, 0x3000);
			fcut("MUS00",     0x35, 0x1a, 0x01, 0x01, 0x01, 0x0000, 0x0800);
			continue;

		case 'B':
			printf("Disk B F܂.\n");
			fcut("DRIVER", 0x01, 0x00, 0x01, 0x02, 0x01, 0x0000, 0x5f00);
			for (i=0; mb[i].sec; i++)
			{
				sprintf(fname,"MUS%02d",i+1);
				fcut(fname, mb[i].trk, mb[i].trk>>1, mb[i].trk&1, mb[i].sec, 0x01, 0x0000, mb[i].size);
			}
			continue;

		case 'C':
			printf("Disk C F܂.\n");
			continue;

		case 'D':
			printf("Disk D F܂.\n");
			continue;
			
		case 'E':
			printf("Disk E F܂.\n");
			continue;
			
		case 'F':
			printf("Disk F F܂.\n");
			continue;

		case 'U':
			printf("User Disk F܂.\n");
			continue;
		}
		printf("FłȂfBXNł.\n");
	}
	return 0;
}

