// The Tug of War (PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	int i,d;

	// for Disk A
	struct fpos ma1[] =
	{
		{ 0x15, 0x01, 0x1000 }, // 6800`
		{ 0x16, 0x01, 0x1000 }, // 6800`
		{ 0x17, 0x01, 0x1000 }, // 6800`
		{ 0x1f, 0x01, 0x0800 }, // 6800`
		{ 0x1f, 0x09, 0x0800 }, // 6800`
		{ 0x4b, 0x01, 0x1000 }, // 6800`
		{ 0x4c, 0x01, 0x1000 }, // 6800`
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};
	struct fpos ma2[] =
	{
		{ 0x49, 0x01, 0x1000 }, // 2000`
		{ 0x4a, 0x01, 0x1000 }, // 2000`
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};

	if (argc != 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);
		disk.ReadDATA1(0x00, 0x00, 0x00, 0x10, 0x01, buff, 0x100);
		switch (buff[0x0f])
		{
		case 'A':
			printf("Disk A F܂.\n");
			fcut("PROG1", 0x47, 0x23, 0x01, 0x02, 0x01, 0x0000, 0x1f00);
			fcut("PROG2", 0x01, 0x00, 0x01, 0x02, 0x01, 0x0000, 0x1f00);
			// ʏQ[p
			for (i=0; ma1[i].sec; i++)
			{
				sprintf(fname,"MUS1%02dA",i);
				fcut(fname, ma1[i].trk, ma1[i].trk>>1, ma1[i].trk&1, ma1[i].sec, 0x01, 0x0000, ma1[i].size);
			}
			// fhCop
			for (i=0; ma2[i].sec; i++)
			{
				sprintf(fname,"MUS1%02dB",i);
				fcut(fname, ma2[i].trk, ma2[i].trk>>1, ma2[i].trk&1, ma2[i].sec, 0x01, 0x0000, ma2[i].size);
			}
			continue;

		case 'B':
			printf("Disk B F܂.\n");
			continue;

		case 'C':
			printf("Disk C F܂.\n");
			continue;

		case 'D':
			printf("Disk D F܂.\n");
			continue;
			
		case 'K':
			printf("User Disk F܂.\n");
			continue;
		}
		printf("FłȂfBXNł.\n");
	}
	return 0;
}

